module CalcColors (x, y, snakex, snakey, seg1, seg2, seg3, seg4, seg5, seg6, applex, appley, clk, reset, R, G, B) ;

input [9:0] x ;
input [9:0] y ;
input [9:0] snakex;
input [9:0] snakey;
input [10:0] seg1;
input [10:0] seg2;
input [10:0] seg3;
input [10:0] seg4;
input [10:0] seg5;
input [10:0] seg6;
input [9:0] applex;   //apple coordinates from center of apple
input [9:0] appley;   //apple coordinates from center of apple
input clk;
input reset;
output R ;
output G ;
output B ;


reg snake1, snake2, snake3, snake4, snake5, snake6;         //tells us if we are within the snake or not
reg [9:0] x2, y2, x3, y3, x4, y4, x5, y5, x6, y6;
reg [10:0] seg2_2, seg3_2, seg4_2, seg5_2, seg6_2, seg3_3, seg4_3, seg5_3, seg6_3, seg4_4, seg5_4, seg6_4, seg5_5, seg6_5, seg6_6;
reg [9:0] snakey2, snakex2, snakey3, snakex3, snakey4, snakex4, snakey5, snakex5, snakey6, snakex6;

reg wall1, wall2, wall3, wall4, wall5, wall6;
reg apple1, apple2, apple3, apple4, apple5, apple6;
wire zero;

// add your declarations here

assign R = (wall6 || apple6) ? 1 : 0;
assign G = (snake6 || wall6) ? 1 : 0;
assign B = wall6 ? 1 : 0;
assign zero = 0;

always @(posedge clk) begin
	if (reset) begin
		snake1 <= 0;
		snake2 <= 0;
		snake3 <= 0;
		snake4 <= 0;
		snake5 <= 0;
		snake6 <= 0;
		wall1 <= 0;
		wall2 <= 0;
		wall3 <= 0;
		wall4 <= 0;
		wall5 <= 0;
		wall6 <= 0;
		apple1  <= 0;
		apple2  <= 0;
		apple3  <= 0;
		apple4  <= 0;
		apple5  <= 0;
		apple6  <= 0;
	end
	
	// Draw wall if coords are in wall
	if((x < 10) || (x > 630) || (y < 10) || (y > 470))
	  wall1 <= 1;
	else
	  wall1 <= 0;
	  
 	//Draw apple if coords are in apple
 	if((x <= applex + 2) && (x >= applex - 2) && (y <= appley + 2) && (y >= appley - 2) )
 	  apple1 <= 1;
 	else
 	  apple1 <= 0; 

	if(seg1[10:9] == 0) begin
	   if((y >= snakey) && (y <= (snakey + {seg1[8:0],zero})) && (x >= snakex - 10) && (x <= snakex + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;
	   if (seg2[10:9] == 2)
	   	snakex2 <= snakex + 10;
	   else
	   	snakex2 <= snakex - 10;
	   snakey2 <= (snakey + {seg1[8:0],zero} - 10);
	end
	if(seg1[10:9] == 1) begin
	   if((y <= snakey) && (y >= (snakey - {seg1[8:0],zero})) && (x >= snakex - 10) && (x <= snakex + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;
	   if (seg2[10:9] == 2)
	   	snakex2 <= snakex + 10;
	   else
	   	snakex2 <= snakex - 10;
	   snakey2 <= (snakey - {seg1[8:0],zero} + 10);	
	end
	if(seg1[10:9] == 2) begin
	   if((x >= snakex) && (x <= (snakex + {seg1[8:0],zero})) && (y >= snakey - 10) && (y <= snakey + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;  
	   snakex2 <= (snakex + {seg1[8:0],zero} - 10);
	   if (seg2[10:9] == 0)
	   	snakey2 <= snakey + 10;
	   else 
	   	snakey2 <= snakey - 10;
	end
	if(seg1[10:9] == 3) begin
	   if((x <= snakex) && (x >= (snakex - {seg1[8:0],zero})) && (y >= snakey - 10) && (y <= snakey + 10))
	   	snake1 <= 1;
	   else
	   	snake1 <= 0;
	   snakex2 <= (snakex - {seg1[8:0],zero} + 10);
	   if (seg2[10:9] == 0)
	   	snakey2 <= snakey + 10;
	   else 
	   	snakey2 <= snakey - 10;
	end
	
	//put values into registers for second stage of pipeline
	y2 <= y;
	x2 <= x;
	seg2_2 <= seg2;
	seg3_2 <= seg3;
	seg4_2 <= seg4;
	seg5_2 <= seg5;
	seg6_2 <= seg6;
	wall2  <= wall1;
	apple2 <= apple1;
	
	//check second segment coordinates and set snake accordingly   
	if(seg2_2[10:9] == 0) begin
	   if((y2 >= snakey2) && (y2 <= (snakey2 + {seg2_2[8:0],zero})) && (x2 >= snakex2 - 10) && (x2 <= snakex2 + 10))
	   	snake2 <= 1;
	   else 
	   	snake2 <= snake1;
	   if (seg3_2[10:9] == 2)
	   	snakex3 <= snakex2 + 10;
	   else
	   	snakex3 <= snakex2 - 10;
	   snakey3 <= (snakey2 + {seg2_2[8:0],zero} - 10);
	end
	else if(seg2_2[10:9] == 1) begin
	   if((y2 <= snakey2) && (y2 >= (snakey2 - {seg2_2[8:0],zero})) && (x2 >= snakex2 - 10) && (x2 <= snakex2 + 10))
	   	snake2 <= 1;	
	   else
	   	snake2 <= snake1;
	   if (seg3_2[10:9] == 2)
	   	snakex3 <= snakex2 + 10;
	   else
	   	snakex3 <= snakex2 - 10;
	   snakey3 <= (snakey2 - {seg2_2[8:0],zero} + 10);	
	end
	else if(seg2_2[10:9] == 2) begin
	   if((x2 >= snakex2) && (x2 <= (snakex2 + {seg2_2[8:0],zero})) && (y2 >= snakey2 - 10) && (y2 <= snakey2 + 10))
	   	snake2 <= 1;
	  else
	       snake2 <= snake1; 
	   snakex3 <= (snakex2 + {seg2_2[8:0],zero} - 10);
	   if (seg3_2[10:9] == 0)
	   	snakey3 <= snakey2 + 10;
	   else 
	   	snakey3 <= snakey2 - 10;
	end
	else if(seg2_2[10:9] == 3) begin
	   if((x2 <= snakex2) && (x2 >= (snakex2 - {seg2_2[8:0],zero})) && (y2 >= snakey2 - 10) && (y2 <= snakey2 + 10))
	   	snake2 <= 1;
	   else 
	   	snake2 <= snake1;
	   snakex3 <= (snakex2 - {seg2_2[8:0],zero} + 10);
	   if (seg3_2[10:9] == 0)
	   	snakey3 <= snakey2 + 10;
	   else 
	   	snakey3 <= snakey2 - 10;
	end
	
	//put values into registers for third stage of pipeline
	y3 <= y2;
	x3 <= x2;
	seg3_3 <= seg3_2;
	seg4_3 <= seg4_2;
	seg5_3 <= seg5_2;
	seg6_3 <= seg6_2;
	wall3 <= wall2;
	apple3 <= apple2;
	
	//check third segment coordinates and set snake accordingly   
	if(seg3_3[10:9] == 0) begin
	   if((y3 >= snakey3) && (y3 <= (snakey3 + {seg3_3[8:0],zero})) && (x3 >= snakex3 - 10) && (x3 <= snakex3 + 10))
	   	snake3 <= 1;
	   else 
	   	snake3 <= snake2;
	   if (seg4_3[10:9] == 2)
	   	snakex4 <= snakex3 + 10;
	   else
	   	snakex4 <= snakex3 - 10;
	   snakey4 <= (snakey3 + {seg3_3[8:0],zero} - 10);
	end
	else if(seg3_3[10:9] == 1) begin
	   if((y3 <= snakey3) && (y3 >= (snakey3 - {seg3_3[8:0],zero})) && (x3 >= snakex3 - 10) && (x3 <= snakex3 + 10))
	   	snake3 <= 1;	
	   else
	   	snake3 <= snake2;
	   if (seg4_3[10:9] == 2)
	   	snakex4 <= snakex3 + 10;
	   else
	   	snakex4 <= snakex3 - 10;
	   snakey4 <= (snakey3 - {seg3_3[8:0],zero} + 10);
	end
	else if(seg3_3[10:9] == 2) begin
	   if((x3 >= snakex3) && (x3 <= (snakex3 + {seg3_3[8:0],zero})) && (y3 >= snakey3 - 10) && (y3 <= snakey3 + 10))
	   	snake3 <= 1;
	  else
	       snake3 <= snake2; 
	  snakex4 <= (snakex3 + {seg3_3[8:0],zero} - 10);
	   if (seg4_3[10:9] == 0)
	   	snakey4 <= snakey3 + 10;
	   else 
	   	snakey4 <= snakey3 - 10;
	end
	else if(seg3_3[10:9] == 3) begin
	   if((x3 <= snakex3) && (x3 >= (snakex3 - {seg3_3[8:0],zero})) && (y3 >= snakey3 - 10) && (y3 <= snakey3 + 10))
	   	snake3 <= 1;
	   else 
	   	snake3 <= snake2;
	   snakex4 <= (snakex3 - {seg3_3[8:0],zero} + 10);
	   if (seg4_3[10:9] == 0)
	   	snakey4 <= snakey3 + 10;
	   else 
	   	snakey4 <= snakey3 - 10;
	end
	
	//put values into registers for fourth stage of pipeline
	y4 <= y3;
	x4 <= x3;
	seg4_4 <= seg4_3;
	seg5_4 <= seg5_3;
	seg6_4 <= seg6_3;
	wall4 <= wall3;
	apple4 <= apple3;
	
	//check fourth segment coordinates and set snake accordingly   
	if(seg4_4[10:9] == 0) begin
	   if((y4 >= snakey4) && (y4 <= (snakey4 + {seg4_4[8:0],zero})) && (x4 >= snakex4 - 10) && (x4 <= snakex4 + 10))
	   	snake4 <= 1;
	   else 
	   	snake4 <= snake3;
	   if (seg5_4[10:9] == 2)
	   	snakex5 <= snakex4 + 10;
	   else
	   	snakex5 <= snakex4 - 10;
	   snakey5 <= (snakey4 + {seg4_4[8:0],zero} - 10);
	end
	else if(seg4_4[10:9] == 1) begin
	   if((y4 <= snakey4) && (y4 >= (snakey4 - {seg4_4[8:0],zero})) && (x4 >= snakex4 - 10) && (x4 <= snakex4 + 10))
	   	snake4 <= 1;	
	   else
	   	snake4 <= snake3;
	   if (seg5_4[10:9] == 2)
	   	snakex5 <= snakex4 + 10;
	   else
	   	snakex5 <= snakex4 - 10;
	   snakey5 <= (snakey4 - {seg4_4[8:0],zero} + 10);
	end
	else if(seg4_4[10:9] == 2) begin
	   if((x4 >= snakex4) && (x4 <= (snakex4 + {seg4_4[8:0],zero})) && (y4 >= snakey4 - 10) && (y4 <= snakey4 + 10))
	   	snake4 <= 1;
	  else
	       snake4 <= snake3; 
	  snakex5 <= (snakex4 + {seg4_4[8:0],zero} - 10);
	   if (seg5_4[10:9] == 0)
	   	snakey5 <= snakey4 + 10;
	   else 
	   	snakey5 <= snakey4 - 10;
	end
	else if(seg4_4[10:9] == 3) begin
	   if((x4 <= snakex4) && (x4 >= (snakex4 - {seg4_4[8:0],zero})) && (y4 >= snakey4 - 10) && (y4 <= snakey4 + 10))
	   	snake4 <= 1;
	   else 
	   	snake4 <= snake3;
	   snakex5 <= (snakex4 - {seg4_4[8:0],zero} + 10);
	   if (seg5_4[10:9] == 0)
	   	snakey5 <= snakey4 + 10;
	   else 
	   	snakey5 <= snakey4 - 10;
	end	

	//put values into registers for fifth stage of pipeline
	y5 <= y4;
	x5 <= x4;
	seg5_5 <= seg5_4;
	seg6_5 <= seg6_4;
	wall5 <= wall4;
	apple5 <= apple4;

	//check fifth segment coordinates and set snake accordingly   
	if(seg5_5[10:9] == 0) begin
	   if((y5 >= snakey5) && (y5 <= (snakey5 + {seg5_5[8:0],zero})) && (x5 >= snakex5 - 10) && (x5 <= snakex5 + 10))
	   	snake5 <= 1;
	   else 
	   	snake5 <= snake4;
	   if (seg6_5[10:9] == 2)
	   	snakex6 <= snakex5 + 10;
	   else
	   	snakex6 <= snakex5 - 10;
	   snakey6 <= (snakey5 + {seg5_5[8:0],zero} - 10);
	end
	else if(seg5_5[10:9] == 1) begin
	   if((y5 <= snakey5) && (y5 >= (snakey5 - {seg5_5[8:0],zero})) && (x5 >= snakex5 - 10) && (x5 <= snakex5 + 10))
	   	snake5 <= 1;	
	   else
	   	snake5 <= snake4;
	   if (seg6_5[10:9] == 2)
	   	snakex6 <= snakex5 + 10;
	   else
	   	snakex6 <= snakex5 - 10;
	   snakey6 <= (snakey5 - {seg5_5[8:0],zero} + 10);
	end
	else if(seg5_5[10:9] == 2) begin
	   if((x5 >= snakex5) && (x5 <= (snakex5 + {seg5_5[8:0],zero})) && (y5 >= snakey5 - 10) && (y5 <= snakey5 + 10))
	   	snake5 <= 1;
	  else
	       snake5 <= snake4; 
	  snakex6 <= (snakex5 + {seg5_5[8:0],zero} - 10);
	   if (seg6_5[10:9] == 0)
	   	snakey6 <= snakey5 + 10;
	   else 
	   	snakey6 <= snakey5 - 10;
	end
	else if(seg5_5[10:9] == 3) begin
	   if((x5 <= snakex5) && (x5 >= (snakex5 - {seg5_5[8:0],zero})) && (y5 >= snakey5 - 10) && (y5 <= snakey5 + 10))
	   	snake5 <= 1;
	   else 
	   	snake5 <= snake4;
	   snakex6 <= (snakex5 - {seg5_5[8:0],zero} + 10);
	   if (seg6_5[10:9] == 0)
	   	snakey6 <= snakey5 + 10;
	   else 
	   	snakey6 <= snakey5 - 10;
	end	

	//put values into registers for sixth stage of pipeline
	y6 <= y5;
	x6 <= x5;
	seg6_6 <= seg6_5;
	wall6 <= wall5;
	apple6 <= apple5;

        //check sixth segment coordinates and set snake accordingly   
	if(seg6_6[10:9] == 0) begin
	   if((y6 >= snakey6) && (y6 <= (snakey6 + {seg6_6[8:0],zero})) && (x6 >= snakex6 - 10) && (x6 <= snakex6 + 10))
	   	snake6 <= 1;
	   else 
	   	snake6 <= snake5;
	end
	else if(seg6_6[10:9] == 1) begin
	   if((y6 <= snakey6) && (y6 >= (snakey6 - {seg6_6[8:0],zero})) && (x6 >= snakex6 - 10) && (x6 <= snakex6 + 10))
	   	snake6 <= 1;	
	   else
	   	snake6 <= snake5;
	end
	else if(seg6_6[10:9] == 2) begin
	   if((x6 >= snakex6) && (x6 <= (snakex6 + {seg6_6[8:0],zero})) && (y6 >= snakey6 - 10) && (y6 <= snakey6 + 10))
	   	snake6 <= 1;
	  else
	       snake6 <= snake5; 
	end
	else if(seg6_6[10:9] == 3) begin
	   if((x6 <= snakex6) && (x6 >= (snakex6 - {seg6_6[8:0],zero})) && (y6 >= snakey6 - 10) && (y6 <= snakey6 + 10))
	   	snake6 <= 1;
	   else 
	   	snake6 <= snake5;
	end		
end


endmodule 

