     module STATEOFGAME (up, down, left, right, reset, clk, HeadX, HeadY, AppleX, AppleY, Seg1, Seg2, Seg3, Seg4, Seg5, Seg6) ;

input up ;
input down ;
input left ;
input right ;
input reset ;
input clk ;
output [9:0] HeadX ;
output [9:0] HeadY ;
output [9:0] AppleX;
output [9:0] AppleY;
output [10:0] Seg1 ;
output [10:0] Seg2 ;
output [10:0] Seg3 ;
output [10:0] Seg4 ;
output [10:0] Seg5 ;
output [10:0] Seg6 ;

// add your declarations here
// X and Y of the head of the snake
reg [9:0] X, HeadX1, HeadX2, HeadX3, HeadX4, HeadX5, HeadX6, HeadX7;
reg [9:0] Y, HeadY1, HeadY2, HeadY3, HeadY4, HeadY5, HeadY6, HeadY7;

// X and Y of the apple center
reg [9:0] aX, aX1, aX2, aX3, aX4, aX5, aX6, aX7;
reg [9:0] aY, aY1, aY2, aY3, aY4, aY5, aY6, aY7;

// Direction and length of first segment
reg [1:0] Seg1Dir, seg1_1dir, seg1_2dir, seg1_3dir, seg1_4dir, seg1_5dir, seg1_6dir, seg1_7dir;
reg [8:0] Seg1Len, seg1_1len, seg1_2len, seg1_3len, seg1_4len, seg1_5len, seg1_6len, seg1_7len;

// Direction and length of second segment
reg [1:0] Seg2Dir, seg2_1dir, seg2_2dir, seg2_3dir, seg2_4dir, seg2_5dir, seg2_6dir, seg2_7dir;
reg [8:0] Seg2Len, seg2_1len, seg2_2len, seg2_3len, seg2_4len, seg2_5len, seg2_6len, seg2_7len;

//Direction and length of third segment
reg [1:0] Seg3Dir, seg3_1dir, seg3_2dir, seg3_3dir, seg3_4dir, seg3_5dir, seg3_6dir, seg3_7dir;
reg [8:0] Seg3Len, seg3_1len, seg3_2len, seg3_3len, seg3_4len, seg3_5len, seg3_6len, seg3_7len;

//Direction and length of fourth segment
reg [1:0] Seg4Dir, seg4_1dir, seg4_2dir, seg4_3dir, seg4_4dir, seg4_5dir, seg4_6dir, seg4_7dir;
reg [8:0] Seg4Len, seg4_1len, seg4_2len, seg4_3len, seg4_4len, seg4_5len, seg4_6len, seg4_7len;

//Direction and length of fifth segment
reg [1:0] Seg5Dir, seg5_1dir, seg5_2dir, seg5_3dir, seg5_4dir, seg5_5dir, seg5_6dir, seg5_7dir;
reg [8:0] Seg5Len, seg5_1len, seg5_2len, seg5_3len, seg5_4len, seg5_5len, seg5_6len, seg5_7len;

//Direction and length of sixth segment
reg [1:0] Seg6Dir, seg6_1dir, seg6_2dir, seg6_3dir, seg6_4dir, seg6_5dir, seg6_6dir, seg6_7dir;
reg [8:0] Seg6Len, seg6_1len, seg6_2len, seg6_3len, seg6_4len, seg6_5len, seg6_6len, seg6_7len;

//X and Y of each segment for the snake
reg [9:0] snakey, snakey2, snakey3, snakey4, snakey5, snakey6;
reg [9:0] snakex, snakex2, snakex3, snakex4, snakex5, snakex6;

reg gameover, gameover1, gameover2, gameover3, gameover4, gameover5, gameover6, gameover7;
reg grow;   //says if our snake needs to grow due to a collision with an apple
reg L;
reg R;
reg U;
reg D;

wire zero;

//assign outputs
assign HeadX = HeadX7;
assign HeadY = HeadY7;
assign Seg1 = {seg1_7dir,seg1_7len};
assign Seg2 = {seg2_7dir,seg2_7len};
assign Seg3 = {seg3_7dir,seg3_7len};
assign Seg4 = {seg4_7dir,seg4_7len};
assign Seg5 = {seg5_7dir,seg5_7len};
assign Seg6 = {seg6_7dir,seg6_7len};
assign AppleX = aX7;
assign AppleY = aY7;
assign zero = 0;

// add your code here
always @(posedge clk) begin

   // Reset the state when the space bar is pressed
   if (reset) begin
	X <= 300;
	Y <= 300;
	HeadX1 <= 300;
	HeadX2 <= 300;
	HeadX3 <= 300;
	HeadX4 <= 300;
	HeadX5 <= 300;
	HeadX6 <= 300;
	HeadX7 <= 300;
	HeadY1 <= 300;
	HeadY2 <= 300;
	HeadY3 <= 300;
	HeadY4 <= 300;
	HeadY5 <= 300;
	HeadY6 <= 300;
	HeadY7 <= 300;
	
	snakey <= 300;
	snakey2 <= 310;
	snakey3 <= 300;
	snakey4 <= 310;
	snakey5 <= 300;
	snakey6 <= 310;
	snakex <= 300;
	snakex2 <= 110;
	snakex3 <= 100;
	snakex4 <= 110;
	snakex5 <= 100;
	snakex6 <= 110;
	
	Seg1Dir <= 3;
	seg1_1dir <= 3;
	seg1_2dir <= 3;
	seg1_3dir <= 3;
	seg1_4dir <= 3;
	seg1_5dir <= 3;
	seg1_6dir <= 3;
	seg1_7dir <= 3;
	Seg1Len <= 100;
	seg1_1len <= 100;
	seg1_2len <= 100;
	seg1_3len <= 100;
	seg1_4len <= 100;
	seg1_5len <= 100;
	seg1_6len <= 100;
	seg1_7len <= 100;
	
	Seg2Dir <= 0;
	seg2_1dir <= 0;
	seg2_2dir <= 0;
	seg2_3dir <= 0;
	seg2_4dir <= 0;
	seg2_5dir <= 0;
	seg2_6dir <= 0;
	seg2_7dir <= 0;
	Seg2Len <= 0;
	seg2_1len <= 0;
	seg2_2len <= 0;
	seg2_3len <= 0;
	seg2_4len <= 0;
	seg2_5len <= 0;
	seg2_6len <= 0;
	seg2_7len <= 0;
	
	Seg3Dir <= 3;
	seg3_1dir <= 3;
	seg3_2dir <= 3;
	seg3_3dir <= 3;
	seg3_4dir <= 3;
	seg3_5dir <= 3;
	seg3_6dir <= 3;
	seg3_7dir <= 3;
	Seg3Len <= 0;
	seg3_1len <= 0;
	seg3_2len <= 0;
	seg3_3len <= 0;
	seg3_4len <= 0;
	seg3_5len <= 0;
	seg3_6len <= 0;
	seg3_7len <= 0;
	
	Seg4Dir <= 0;
	seg4_1dir <= 0;
	seg4_2dir <= 0;
	seg4_3dir <= 0;
	seg4_4dir <= 0;
	seg4_5dir <= 0;
	seg4_6dir <= 0;
	seg4_7dir <= 0;
	Seg4Len <= 0;
	seg4_1len <= 0;
	seg4_2len <= 0;
	seg4_3len <= 0;
	seg4_4len <= 0;
	seg4_5len <= 0;
	seg4_6len <= 0;
	seg4_7len <= 0;
	
	Seg5Dir <= 3;
	seg5_1dir <= 3;
	seg5_2dir <= 3;
	seg5_3dir <= 3;
	seg5_4dir <= 3;
	seg5_5dir <= 3;
	seg5_6dir <= 3;
	seg5_7dir <= 3;
	Seg5Len <= 0;
	seg5_1len <= 0;
	seg5_2len <= 0;
	seg5_3len <= 0;
	seg5_4len <= 0;
	seg5_5len <= 0;
	seg5_6len <= 0;
	seg5_7len <= 0;
	
	Seg6Dir <= 0;
	seg6_1dir <= 0;
	seg6_2dir <= 0;
	seg6_3dir <= 0;
	seg6_4dir <= 0;
	seg6_5dir <= 0;
	seg6_6dir <= 0;
	seg6_7dir <= 0;
	Seg6Len <= 0;
	seg6_1len <= 0;
	seg6_2len <= 0;
	seg6_3len <= 0;
	seg6_4len <= 0;
	seg6_5len <= 0;
	seg6_6len <= 0;
	seg6_7len <= 0;
	
	gameover <= 0;
	gameover1 <= 0;
	gameover2 <= 0;
	gameover3 <= 0;
	gameover4 <= 0;
	gameover5 <= 0;
	gameover6 <= 0;
	gameover7 <= 0;
	grow = 0;
	aX <= 200;
	aX1 <= 200;
	aX2 <= 200;
	aX3 <= 200;
	aX4 <= 200;
	aX5 <= 200;
	aX6 <= 200;
	aX7 <= 200;
	aY <= 150;
	aY1 <= 150;
	aY2 <= 150;
	aY3 <= 150;
	aY4 <= 150;
	aY5 <= 150;
	aY6 <= 150;
	aY7 <= 150;
	L <= 1;
	R <= 0;
	U <= 1;
	D <= 1;
   end
	
   else if (gameover7 != 1) begin 
	
   // Check for user input
	if (up && U && (D != 0)) begin   //pressed up
		Y <= Y - 10;
		if(Seg1Dir == 2) 
		    X <= X + 10;
		else
		    X <= X - 10;
		    
		Seg6Len <= Seg5Len;
		Seg5Len <= Seg4Len;
		Seg4Len <= Seg3Len;
		Seg3Len <= Seg2Len;
		Seg2Len <= Seg1Len - 10;
		Seg1Len <= 10;
		
		Seg6Dir <= Seg5Dir;
		Seg5Dir <= Seg4Dir;
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 0;
		
		U <= 0;
		L <= 1;
		R <= 1;
		D <= 1;
	end
	else if (down && D && (U != 0)) begin
		Y <= Y + 10;
		if(Seg1Dir == 2)
		   X <= X + 10;
		else 
		   X <= X - 10;
		   
		Seg6Len <= Seg5Len;
		Seg5Len <= Seg4Len;
		Seg4Len <= Seg3Len;
		Seg3Len <= Seg2Len;
		Seg2Len <= Seg1Len - 10;
		Seg1Len <= 10;
		
		Seg6Dir <= Seg5Dir;
		Seg5Dir <= Seg4Dir;
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 1;
		
		D <= 0;
		L <= 1;
		R <= 1;
		U <= 1;
	end
	else if (right && R && (L != 0)) begin
		X <= X + 10;
		if(Seg1Dir == 0)
		     Y <= Y + 10;
		else 
		     Y <= Y - 10;
		   
		Seg6Len <= Seg5Len;
		Seg5Len <= Seg4Len; 
		Seg4Len <= Seg3Len;
		Seg3Len <= Seg2Len;
		Seg2Len <= Seg1Len - 10;
		Seg1Len <= 10;
	
		Seg6Dir <= Seg5Dir;
		Seg5Dir <= Seg4Dir;
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 3;
		
		R <= 0;
		L <= 1;
		D <= 1;
		U <= 1;
	end
	else if (left && L && (R != 0)) begin
		X <= X - 10;
		if(Seg1Dir == 0) 
		     Y <= Y + 10;
		else 
		     Y <= Y - 10;
		
		Seg6Len <= Seg5Len;
		Seg5Len <= Seg4Len;
		Seg4Len <= Seg3Len;
		Seg3Len <= Seg2Len;
		Seg2Len <= Seg1Len - 10;
		Seg1Len <= 10;
		
		Seg6Dir <= Seg5Dir;
		Seg5Dir <= Seg4Dir;
		Seg4Dir <= Seg3Dir;
		Seg3Dir <= Seg2Dir;
		Seg2Dir <= Seg1Dir;
		Seg1Dir <= 2;
	
		L <= 0;
		R <= 1;
		D <= 1;
		U <= 1;
	end
	
	// Move the snake and check for collisions with apples, walls, and yourself
	else begin
		if(Seg1Dir == 0) begin
		   Y <= Y - 2;
		   if((aY >= Y - 2) && (aY <= Y) && (aX <= X + 10) && (aX >= X - 10))begin
		  	grow = 1;
		   end
		   else
		   	grow = 0;
		   	
		   if( Y  <= 10)  //checking top boundary
		   	gameover <= 1;
		   else
		   	gameover <= 0;
		end
		if(Seg1Dir == 1) begin             
		   Y <= Y + 2;
		    if((aY <= Y + 2) && (aY >= Y) && (aX <= X + 10) && (aX >= X - 10))begin
		    	grow = 1;
		   end
		   else
		   	grow = 0;
		   if( Y  >= 470)   //checking bottom boundary
		   	gameover <= 1;
		   else
		   	gameover <= 0;
		end
		if(Seg1Dir == 2) begin
		   X <= X - 2;
		   if((aY <= Y + 10) && (aY >= Y - 10) && (aX >= X - 2) && (aX <= X))begin
		   	grow = 1;
		   end
		   else
		   	grow = 0;
		   if ( X  <= 10)  //checking left boundary
		   	gameover <= 1;
		   else
		   	gameover <= 0;
		end
		if(Seg1Dir == 3) begin
		   X <= X + 2;
		   if((aY <= Y + 10) && (aY >= Y - 10) && (aX <= X + 2) && (aX >= X))begin
		   	grow = 1;
		   end
		   else 
		   	grow = 0;
		   if( X  >= 630)    //checking right boundary
		   	gameover <= 1;
		   else
		   	gameover <= 0;
		end
	
	
		// Move the snake, growing if grow is true
		if (Seg6Len != 0 ) begin
			 Seg1Len <= Seg1Len + 1;
			 if(!grow)
			    Seg6Len <= Seg6Len - 1;
			 else
			    Seg6Len <= Seg6Len + 9;
		end
		else if (Seg5Len != 0) begin
			 Seg1Len <= Seg1Len + 1;
			 if(!grow)
			    Seg5Len <= Seg5Len - 1;
			 else
			    Seg5Len <= Seg5Len + 9;
		end
		else if (Seg4Len != 0 ) begin	 
			 Seg1Len <= Seg1Len + 1;
			 if(!grow)
			    Seg4Len <= Seg4Len - 1;
			 else
			    Seg4Len <= Seg4Len + 9;
	  	end
		else if (Seg3Len != 0 ) begin
			 Seg1Len <= Seg1Len + 1;
			 if(!grow)
			    Seg3Len <= Seg3Len - 1;
			 else
			    Seg3Len <= Seg3Len + 9;
	        end
		else if (Seg2Len != 0 ) begin
			 Seg1Len <= Seg1Len + 1;
			 if(!grow)
			    Seg2Len <= Seg2Len - 1;
			 else 
			    Seg2Len <= Seg2Len + 9;   	
		end	
		else if (grow) begin
			Seg1Len <= Seg1Len + 10;
		end
		
		// Move the apple to a new location if eaten
		if (grow) begin
			if (aX == 200) begin
				aX <= 400;
				aY <= 450;
			end
			else if (aX == 400) begin
				aX <= 600;
				aY <= 20;
			end
			else if (aX == 600) begin
				aX <= 100;
				aY <= 300;
			end
			else if (aX == 100) begin
				aX <= 150;
				aY <= 220;
			end
			else if (aX == 150) begin
				aX <= 35;
				aY <= 35;
			end
			else begin
				aX <= 200;
				aY <= 455;
			end
			grow = 0;
		end
	end
	
	//registers to pass on to pipeline
	snakey <= Y;
	snakex <= X;
	HeadY1 <= Y;
	HeadX1 <= X;
	aX1 <= aX;
	aY1 <= aY;
	seg1_1dir <= Seg1Dir;
	seg2_1dir <= Seg2Dir;
	seg3_1dir <= Seg3Dir;
	seg4_1dir <= Seg4Dir;
	seg5_1dir <= Seg5Dir;
	seg6_1dir <= Seg6Dir;
	seg1_1len <= Seg1Len;
	seg2_1len <= Seg2Len;
	seg3_1len <= Seg3Len;
	seg4_1len <= Seg4Len;
	seg5_1len <= Seg5Len;
	seg6_1len <= Seg6Len;
	gameover1 <= gameover;
	
	//pipeline to find collisions with yourself: stage 1
	if(seg1_1dir == 0) begin
	   if (seg2_1dir == 2)
	   	snakex2 <= snakex + 10;
	   else
	   	snakex2 <= snakex - 10;
	   snakey2 <= (snakey + {seg1_1len,zero} - 10);
	end
	if(seg1_1dir == 1) begin
	   if (seg2_1dir == 2)
	   	snakex2 <= snakex + 10;
	   else
	   	snakex2 <= snakex - 10;
	   snakey2 <= (snakey - {seg1_1len,zero} + 10);	
	end
	if(seg1_1dir == 2) begin
	   snakex2 <= (snakex + {seg1_1len,zero} - 10);
	   if (seg2_1dir == 0)
	   	snakey2 <= snakey + 10;
	   else 
	   	snakey2 <= snakey - 10;
	end
	if(seg1_1dir == 3) begin
	   snakex2 <= (snakex - {seg1_1len,zero} + 10);
	   if (seg2_1dir == 0)
	   	snakey2 <= snakey + 10;
	   else 
	   	snakey2 <= snakey - 10;
	end
	
	//put values into registers for second stage of collision pipeline
	seg1_2dir <= seg1_1dir;
	seg2_2dir <= seg2_1dir;
	seg3_2dir <= seg3_1dir;
	seg4_2dir <= seg4_1dir;
	seg5_2dir <= seg5_1dir;
	seg6_2dir <= seg6_1dir;
	seg1_2len <= seg1_1len;
	seg2_2len <= seg2_1len;
	seg3_2len <= seg3_1len;
	seg4_2len <= seg4_1len;
	seg5_2len <= seg5_1len;
	seg6_2len <= seg6_1len;
	HeadY2 <= HeadY1;
	HeadX2 <= HeadX1;
	aX2 <= aX1;
	aY2 <= aY1;
	gameover2 <= gameover1;
	
	//check second segment coordinates and set snake accordingly   
	if(seg2_2dir == 0) begin
	   if (seg3_2dir == 2)
	   	snakex3 <= snakex2 + 10;
	   else
	   	snakex3 <= snakex2 - 10;
	   snakey3 <= (snakey2 + {seg2_2len,zero} - 10);
	end
	else if(seg2_2dir == 1) begin
	   if (seg3_2dir == 2)
	   	snakex3 <= snakex2 + 10;
	   else
	   	snakex3 <= snakex2 - 10;
	   snakey3 <= (snakey2 - {seg2_2len,zero} + 10);	
	end
	else if(seg2_2dir == 2) begin
	   snakex3 <= (snakex2 + {seg2_2len,zero} - 10);
	   if (seg3_2dir == 0)
	   	snakey3 <= snakey2 + 10;
	   else 
	   	snakey3 <= snakey2 - 10;
	end
	else if(seg2_2dir == 3) begin
	   snakex3 <= (snakex2 - {seg2_2len,zero} + 10);
	   if (seg3_2dir == 0)
	   	snakey3 <= snakey2 + 10;
	   else 
	   	snakey3 <= snakey2 - 10;
	end
	
	//put values into registers for third stage of pipeline
	seg1_3dir <= seg1_2dir;
	seg2_3dir <= seg2_2dir;
	seg3_3dir <= seg3_2dir;
	seg4_3dir <= seg4_2dir;
	seg5_3dir <= seg5_2dir;
	seg6_3dir <= seg6_2dir;
	seg1_3len <= seg1_2len;
	seg2_3len <= seg2_2len;
	seg3_3len <= seg3_2len;
	seg4_3len <= seg4_2len;
	seg5_3len <= seg5_2len;
	seg6_3len <= seg6_2len;
	HeadY3 <= HeadY2;
	HeadX3 <= HeadX2;
	aX3 <= aX2;
	aY3 <= aY2;
	gameover3 <= gameover2;
	
	//check third segment coordinates and set snake accordingly   
	if(seg3_3dir == 0) begin
	   if (seg4_3dir == 2)
	   	snakex4 <= snakex3 + 10;
	   else
	   	snakex4 <= snakex3 - 10;
	   snakey4 <= (snakey3 + {seg3_3len,zero} - 10);
	end
	else if(seg3_3dir == 1) begin
	   if (seg4_3dir == 2)
	   	snakex4 <= snakex3 + 10;
	   else
	   	snakex4 <= snakex3 - 10;
	   snakey4 <= (snakey3 - {seg3_3len,zero} + 10);
	end
	else if(seg3_3dir == 2) begin
	   snakex4 <= (snakex3 + {seg3_3len,zero} - 10);
	   if (seg4_3dir == 0)
	   	snakey4 <= snakey3 + 10;
	   else 
	   	snakey4 <= snakey3 - 10;
	end
	else if(seg3_3dir == 3) begin
	   snakex4 <= (snakex3 - {seg3_3len,zero} + 10);
	   if (seg4_3dir == 0)
	   	snakey4 <= snakey3 + 10;
	   else 
	   	snakey4 <= snakey3 - 10;
	end
	
	//put values into registers for fourth stage of pipeline
	seg1_4dir <= seg1_3dir;
	seg2_4dir <= seg2_3dir;
	seg3_4dir <= seg3_3dir;
	seg4_4dir <= seg4_3dir;
	seg5_4dir <= seg5_3dir;
	seg6_4dir <= seg6_3dir;
	seg1_4len <= seg1_3len;
	seg2_4len <= seg2_3len;
	seg3_4len <= seg3_3len;
	seg4_4len <= seg4_3len;
	seg5_4len <= seg5_3len;
	seg6_4len <= seg6_3len;
	HeadY4 <= HeadY3;
	HeadX4 <= HeadX3;
	aX4 <= aX3;
	aY4 <= aY3;
	gameover4 <= gameover3;

	//check fourth segment coordinates and set snake accordingly   
	if(seg4_4dir == 0) begin
	   if((HeadY4 >= snakey4) && (HeadY4 <= (snakey4 + {seg4_4len,zero})) && (HeadX4 >= snakex4 - 10) && (HeadX4 <= snakex4 + 10))
	   	gameover5 <= 1;
	   else
	   	gameover5 <= gameover4;
	   if (seg5_4dir == 2)
	   	snakex5 <= snakex4 + 10;
	   else
	   	snakex5 <= snakex4 - 10;
	   snakey5 <= (snakey4 + {seg4_4len,zero} - 10);
	end
	else if(seg4_4dir == 1) begin
	   if((HeadY4 <= snakey4) && (HeadY4 >= (snakey4 - {seg4_4len,zero})) && (HeadX4 >= snakex4 - 10) && (HeadX4 <= snakex4 + 10))
	   	gameover5 <= 1;	
	   else
	   	gameover5 <= gameover4;
	   if (seg5_4dir == 2)
	   	snakex5 <= snakex4 + 10;
	   else
	   	snakex5 <= snakex4 - 10;
	   snakey5 <= (snakey4 - {seg4_4len,zero} + 10);
	end
	else if(seg4_4dir == 2) begin
	   if((HeadX4 >= snakex4) && (HeadX4 <= (snakex4 + {seg4_4len,zero})) && (HeadY4 >= snakey4 - 10) && (HeadY4 <= snakey4 + 10))
	   	gameover5 <= 1;
	   else
	   	gameover5 <= gameover4;
	   snakex5 <= (snakex4 + {seg4_4len,zero} - 10);
	   if (seg5_4dir == 0)
	   	snakey5 <= snakey4 + 10;
	   else 
	   	snakey5 <= snakey4 - 10;
	end
	else if(seg4_4dir == 3) begin
	   if((HeadX4 <= snakex4) && (HeadX4 >= (snakex4 - {seg4_4len,zero})) && (HeadY4 >= snakey4 - 10) && (HeadY4 <= snakey4 + 10))
	   	gameover5 <= 1;
	   else 
	   	gameover5 <= gameover4;
	   snakex5 <= (snakex4 - {seg4_4len,zero} + 10);
	   if (seg5_4dir == 0)
	   	snakey5 <= snakey4 + 10;
	   else 
	   	snakey5 <= snakey4 - 10;
	end	
	
	//put values into registers for fifth stage of pipeline
	seg1_5dir <= seg1_4dir;
	seg2_5dir <= seg2_4dir;
	seg3_5dir <= seg3_4dir;
	seg4_5dir <= seg4_4dir;
	seg5_5dir <= seg5_4dir;
	seg6_5dir <= seg6_4dir;
	seg1_5len <= seg1_4len;
	seg2_5len <= seg2_4len;
	seg3_5len <= seg3_4len;
	seg4_5len <= seg4_4len;
	seg5_5len <= seg5_4len;
	seg6_5len <= seg6_4len;
	HeadY5 <= HeadY4;
	HeadX5 <= HeadX4;
	aX5 <= aX4;
	aY5 <= aY4;

	//check fifth segment coordinates and set snake accordingly   
	if(seg5_5dir == 0) begin
	   if((HeadY5 >= snakey5) && (HeadY5 <= (snakey5 + {seg5_5len,zero})) && (HeadX5 >= snakex5 - 10) && (HeadX5 <= snakex5 + 10))
	   	gameover6 <= 1;
	   else
	   	gameover6 <= gameover5;
	   if (seg6_5dir == 2)
	   	snakex6 <= snakex5 + 10;
	   else
	   	snakex6 <= snakex5 - 10;
	   snakey6 <= (snakey5 + {seg5_5len,zero} - 10);
	end
	else if(seg5_5dir == 1) begin
	   if((HeadY5 <= snakey5) && (HeadY5 >= (snakey5 - {seg5_5len,zero})) && (HeadX5 >= snakex5 - 10) && (HeadX5 <= snakex5 + 10))
	   	gameover6 <= 1;	
	   else 
	   	gameover6 <= gameover5;
	   if (seg6_5dir == 2)
	   	snakex6 <= snakex5 + 10;
	   else
	   	snakex6 <= snakex5 - 10;
	   snakey6 <= (snakey5 - {seg5_5len,zero} + 10);
	end
	else if(seg5_5dir == 2) begin
	   if((HeadX5 >= snakex5) && (HeadX5 <= (snakex5 + {seg5_5len,zero})) && (HeadY5 >= snakey5 - 10) && (HeadY5 <= snakey5 + 10))
	   	gameover6 <= 1;
	   else 
	   	gameover6 <= gameover5;
	   snakex6 <= (snakex5 + {seg5_5len,zero} - 10);
	   if (seg6_5dir == 0)
	   	snakey6 <= snakey5 + 10;
	   else 
	   	snakey6 <= snakey5 - 10;
	end
	else if(seg5_5dir == 3) begin
	   if((HeadX5 <= snakex5) && (HeadX5 >= (snakex5 - {seg5_5len,zero})) && (HeadY5 >= snakey5 - 10) && (HeadY5 <= snakey5 + 10))
	   	gameover6 <= 1;
	   else
	   	gameover6 <= gameover5;
	   snakex6 <= (snakex5 - {seg5_5len,zero} + 10);
	   if (seg6_5dir == 0)
	   	snakey6 <= snakey5 + 10;
	   else 
	   	snakey6 <= snakey5 - 10;
	end	
	
	//put values into registers for sixth stage of pipeline
	seg1_6dir <= seg1_5dir;
	seg2_6dir <= seg2_5dir;
	seg3_6dir <= seg3_5dir;
	seg4_6dir <= seg4_5dir;
	seg5_6dir <= seg5_5dir;
	seg6_6dir <= seg6_5dir;
	seg1_6len <= seg1_5len;
	seg2_6len <= seg2_5len;
	seg3_6len <= seg3_5len;
	seg4_6len <= seg4_5len;
	seg5_6len <= seg5_5len;
	seg6_6len <= seg6_5len;
	HeadY6 <= HeadY5;
	HeadX6 <= HeadX5;
	aX6 <= aX5;
	aY6 <= aY5;

	//check fifth segment coordinates and set snake accordingly   
	if(seg6_6dir == 0) begin
	   if((HeadY6 >= snakey6) && (HeadY6 <= (snakey6 + {seg6_6len,zero})) && (HeadX6 >= snakex6 - 10) && (HeadX6 <= snakex6 + 10))
	   	gameover7 <= 1;
	   else 
	   	gameover7 <= gameover6;
	end
	else if(seg6_6dir == 1) begin
	   if((HeadY6 <= snakey6) && (HeadY6 >= (snakey6 - {seg6_6len,zero})) && (HeadX6 >= snakex6 - 10) && (HeadX6 <= snakex6 + 10))
	   	gameover7 <= 1;	
	   else
	   	gameover7 <= gameover6;
	end
	else if(seg6_6dir == 2) begin
	   if((HeadX6 >= snakex6) && (HeadX6 <= (snakex6 + {seg6_6len,zero})) && (HeadY6 >= snakey6 - 10) && (HeadY6 <= snakey6 + 10))
	   	gameover7 <= 1;
	   else
	   	gameover7 <= gameover6;
	end
	else if(seg6_6dir == 3) begin
	   if((HeadX6 <= snakex6) && (HeadX6 >= (snakex6 - {seg6_6len,zero})) && (HeadY6 >= snakey6 - 10) && (HeadY6 <= snakey6 + 10))
	   	gameover7 <= 1;
	   else
	   	gameover7 <= gameover6;
	end	
	
	seg1_7dir <= seg1_6dir;
	seg2_7dir <= seg2_6dir;
	seg3_7dir <= seg3_6dir;
	seg4_7dir <= seg4_6dir;
	seg5_7dir <= seg5_6dir;
	seg6_7dir <= seg6_6dir;
	seg1_7len <= seg1_6len;
	seg2_7len <= seg2_6len;
	seg3_7len <= seg3_6len;
	seg4_7len <= seg4_6len;
	seg5_7len <= seg5_6len;
	seg6_7len <= seg6_6len;
	HeadY7 <= HeadY6;
	HeadX7 <= HeadX6;
	aX7 <= aX6;
	aY7 <= aY6;
   end
end

endmodule 
